/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "BaseObjectModel.h"

// Sigmod includes
#include <sigmod/Object.h>

using namespace Sigmod;
using namespace Sigmodr::Tree;

BaseObjectModel::BaseObjectModel(BaseModel* parent, Object* object) :
        BaseModel(parent, object, "")
{
}

BaseObjectModel::~BaseObjectModel()
{
}

QVariant BaseObjectModel::data(int role) const
{
    return BaseModel::data(role);
}

Qt::ItemFlags BaseObjectModel::flags() const
{
    return Qt::ItemIsDragEnabled | Qt::ItemIsSelectable | Qt::ItemIsDropEnabled | Qt::ItemIsEnabled;
}

Qt::DropActions BaseObjectModel::supportedDragActions() const
{
    return Qt::CopyAction | Qt::MoveAction;
}

Qt::DropActions BaseObjectModel::supportedDropActions() const
{
    return Qt::CopyAction | Qt::MoveAction;
}

QString BaseObjectModel::type() const
{
    return m_object->className();
}

int BaseObjectModel::findChild(BaseModel* model) const
{
    Q_UNUSED(model)
    return -1;
}
