/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Header include
#include "RootModel.h"

// Sigmodr tree includes
#include "GameModel.h"

// Sigmod includes
#include <sigmod/Game.h>

using namespace Sigmod;
using namespace Sigmodr::Tree;

RootModel::RootModel() :
        GroupModel(NULL, NULL)
{
}

bool RootModel::setData(const QVariant& value, int role)
{
    Q_UNUSED(value)
    Q_UNUSED(role)
    return false;
}

void RootModel::addGame(Game* game)
{
    addChild(new GameModel(this, game));
}

void RootModel::deleteGame(const Game* game)
{
    for (int i = 0; i < m_objects.size(); ++i)
    {
        if (m_objects[i]->object() == game)
        {
            delete m_objects[i];
            m_objects.removeAt(i);
            break;
        }
    }
}

QString RootModel::types() const
{
    return "Sigmod";
}

void RootModel::addObject(Object* object)
{
    Q_UNUSED(object)
}

void RootModel::deleteObject(BaseModel* model)
{
    Q_UNUSED(model)
}
