/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODRWIDGETS_MAPTRAINERUI_P
#define SIGMODRWIDGETS_MAPTRAINERUI_P

// Header include
#include "MapTrainerUI.h"

// Sigmodr widget includes
#include "ObjectUIPrivate.h"

// Forward declarations
class KActionSelector;
class KComboBox;
class KIntNumInput;
class KLineEdit;
class QListWidgetItem;
namespace Sigcore
{
class Script;
}

namespace Sigmodr
{
namespace CoreWidgets
{
class ScriptWidget;
}

namespace Widgets
{
class SIGMODRWIDGETS_NO_EXPORT MapTrainerUI::Private : public ObjectUIPrivate
{
    Q_OBJECT
    
    public:
        Private(Sigmod::MapTrainer* trainer);
        ~Private();
        
        QWidget* makeWidgets(ObjectUI* widget);
        
        Sigmod::MapTrainer* m_trainer;
    public slots:
        void refreshGui();
        void resetGui();
    protected slots:
        void nameChanged(const QString& name);
        void trainerClassChanged(const int trainerClass);
        void numberFightChanged(const int numberFight);
        void scriptChanged(const Sigcore::Script& script);
        void leadTeamMemberAdded(QListWidgetItem* item);
        void leadTeamMemberRemoved(QListWidgetItem* item);
    private:
        KLineEdit* ui_name;
        KComboBox* ui_trainerClass;
        KIntNumInput* ui_numberFight;
        CoreWidgets::ScriptWidget* ui_script;
        KActionSelector* ui_leadTeamMembers;
};
}
}

#endif
